#!/usr/bin/env bash

# Ce fichier permet de déployer rapidement le projet sur les ordinateurs de l'HEPIA
salle_404=$(seq -f "129.194.187.%g" 51 64)
salle_406=$(seq -f "129.194.184.%g" 101 249)
salle_432=$(seq -f "129.194.187.%g" 141 158; seq -f "129.194.187.%g" 127 130)
salle_433=$(seq -f "129.194.187.%g" 161 187)

if [ $# -eq 0 ]; then
    echo "Usage : ./deploy.sh {salles: 404|406|432|433}"
else
	echo "HEPIA - Ce script part du principe que la dernière version du script se trouve dans le dossier /~/bachelor-scrapper-058.
	Dans le cas où ce n'est pas le cas, mettez le projet dans le dossier ci-contre. Il sera synchronisé sur tous les ordinateurs.
	ATTENTION : Il ne faut PAS faire tourner ce travail dans le dossier utilisateur, il s'agit d'un partage réseau."
	for i in "$@"
	do
		echo "Deploiement sur les ordinateurs de la $i..."
		if [ $i -eq 404 ]; then
			current=$salle_404
		elif [ $i -eq 406 ]; then
			current=$salle_406
		elif [ $i -eq 432 ]; then
			current=$salle_432
		elif [ $i -eq 433 ]; then
			current=$salle_433
		else
			echo "Il faut mettre une salle qui existe. Sinon ca marche pas bien."
			exit
		fi
		# IMPORTANT : Lancer la commande python3.8 -m pip install -r ~/bachelor-scrapper-058/projet/requirements.txt UNE
		# 				FOIS sur un seul ordinateur de l'HEPIA.
		# Itération sur la salle courante...
		for host in $current
		do
			echo "Lancement du script sur $host..."
			# ATTENTION : IL FAUT AVOIR CONFIGURE LE DEPLOYEUR POUR SE CONNECTER PAR SSH AUX ORDINATEURS
			# Sinon ca prend des heures à déployer. Et c'est nul.
			echo "Execution de ssh $(whoami)@$host 'bash -s' < install.sh..."
			ssh -o ConnectTimeout=1 -o "UserKnownHostsFile=/dev/null" -o "StrictHostKeyChecking=no" $(whoami)@$host 'bash -s' << EOF
rm -rf /tmp/bachelor-scrapper-058
cp -r ~/bachelor-scrapper-058 /tmp # REPLACE BY /usr/local/scratch/theo.pirkl/ ONCE OK
cd /tmp/bachelor-scrapper-058/projet || exit # Failsafe si pas hepia ou erreur
# Attention : pas de venv !
nohup python3.8 src/start.py --remote > /dev/null 2>&1 &
EOF
		done
	done
fi