import scrapy


class FAOGeneveSpider(scrapy.Spider):
	name: str = "FAOGeneve"
	start_urls: list = ["https://fao.ge.ch/"]
	counter: int = 0
	pages: list = []
	currentPage: int = 0

	def __init__(self, pages: str, **kwargs):
		super().__init__(**kwargs)  # python3
		self.pages = pages.split(",")

	def parse(self, response):
		if "/captcha" in response.url:
			noCaptcha = response.url.replace("/captcha", "/login")
			yield scrapy.Request(noCaptcha, callback=self.parse)
		else:
			if "?page=" + str(self.currentPage) in response.url or "?page=" not in response.url and 0 in self.pages:
				dateSelector = './/div[contains(@class, "entete")]/div[@class="col-date"]/div[@class="fao_date"]/'
				daySelector = dateSelector + 'div[@class="jour"]/text()'
				monthSelector = dateSelector + 'div[@class="mois"]/text()'
				yearSelector = dateSelector + 'div[@class="annee"]/text()'

				for article in response.xpath('//*[contains(@class, "fao-avis")]'):
					yield {
						'concern': article.xpath('.//div[contains(@class, "entete")]/div['
						                         '@class="col-content"]/h1/span[@class="fao-sousrubrique"]/a/text()')
							.extract_first(),
						'date': article.xpath(daySelector).extract_first() + "/"
						        + article.xpath(monthSelector).extract_first() + "/"
						        + article.xpath(yearSelector).extract_first(),
						'file_urls': [self.start_urls[0] + article.xpath(".//div[3]/div[2]/p/a/@href").extract_first()]

					}
					self.counter += 1

			if len(self.pages) > 0:
				self.currentPage = self.pages.pop(0)
				yield scrapy.Request(self.start_urls[0] + "?page=" + self.currentPage)
