from random_user_agent.params import SoftwareName, OperatingSystem
from random_user_agent.user_agent import UserAgent
from selenium import webdriver
from os import getenv as env


class Utils:
	@staticmethod
	# Converts a month number into a month name (1 -> January)
	def monthNumberToMonthName(monthID):
		return [
			"Janvier",
			"Février",
			"Mars",
			"Avril",
			"Mai",
			"Juin",
			"Juillet",
			"Août",
			"Septembre",
			"Octobre",
			"Novembre",
			"Décembre"
		][monthID]

	# Gets a random user agent for a PC
	@staticmethod
	def getRandomUserAgent():
		software_names = [SoftwareName.CHROME.value]
		operating_systems = [OperatingSystem.WINDOWS.value, OperatingSystem.LINUX.value]

		user_agent_rotator = UserAgent(software_names=software_names, operating_systems=operating_systems, limit=100)

		# Get Random User Agent String.
		user_agent = user_agent_rotator.get_random_user_agent()

		return user_agent

	# Gets a basic
	@staticmethod
	def getBasicOptions():
		options = webdriver.FirefoxOptions()
		options.add_argument("--headless")
		options.add_argument('--disable-gpu')
		options.add_argument("--disable-notifications")
		options.add_argument('--no-sandbox')
		options.add_argument('--verbose')
		options.add_argument('--lang=fr')
		options.add_argument('--disable-web-security')
		options.add_argument('--allow-running-insecure-content')
		options.add_argument('user-agent=' + Utils.getRandomUserAgent())

		options.set_preference("browser.helperApps.neverAsk.saveToDisk", "application/vnd.openxmlformats"
		                                                                 "-officedocument.spreadsheetml.sheet")
		options.set_preference("browser.download.useDownloadDir", True)
		options.set_preference("browser.download.folderList", 2)
		options.set_preference("browser.download.dir", env("FILE_LOCKER"))

		return options
