from os import getenv as env

from dotenv import load_dotenv, find_dotenv
from flask import Flask
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker, Session

load_dotenv(find_dotenv())
# Web Server
app = Flask(__name__)


def getEngine():
    fqdn = "mysql://{0}:{1}@{2}/{3}".format(env("DB_USERNAME"), env("DB_PASSWORD"), env("DB_HOSTNAME"),
                                            env("DB_DATABASE"))
    return create_engine(fqdn, pool_size=20, max_overflow=0)


# DB
def getSession(engine=getEngine()) -> Session:
    sess = sessionmaker(bind=engine)
    return sess()
