# Conclusion {-}

Le but de ce travail était de mettre en place une solution de scraping suffisamment flexible pour qu'elle soit utilisée sur théoriquement n'importe quel site et par n'importe qui. Un framework de scraping a en effet été conçu, nommé Inari. La démarche suivie était de proposer, à la façon de bien des logiciels, un système ne nécessitant aucune connaissance en informatique mais la simple rédaction d'un fichier de commandes.
Inari permet à l'heure actuelle de télécharger de façon efficace des documents sur plusieurs sites (et peut être étendu vers d'autres) de cette façon, mais ne permet pas encore suffisamment d'être utilisé par n'importe qui. Les résultats obtenus sont prometteurs : ils montrent à quel point on peut gagner en performance en quelques actions simples. Les résultats montrent aussi à quel point les scrapers sont sensibles aux changements des sites web et à quel point il est nécessaire de les tenir à jour.

Durant la création de ce travail et la rédaction de ce rapport, j'ai eu l'occasion de découvrir le sujet du scraping en profondeur et de découvrir des difficultés me semblant au début du travail inexistantes. J'ai pu expérimenter les avantages du multiprocessing et de la distribution des tâches; ce fut certainement un des sujets présent dans ce travail qui m'a apporté le plus de connaissances et de problèmes.
J'ai eu l'occasion durant ce travail de Bachelor de fabriquer un outil de scraping : j'ai pu voir à quel point il était performant et à quel point il était aussi sensible au changement. Sensible car le scraper dépend des IDs de chaque élément pour pouvoir se repérer sur la page web. Il est possible d'utiliser des XPath ne dépendant pas d'un ID, mais le problème sera le même. Si la structure est changée, l'expression XPath échouera (l'expression XPath étant dépendante soit de la structure, qu'il s'agisse d'un ID ou non) et le scraper aussi. Il est difficile de proposer une solution à ce problème, mais c'est une problématique qui sera étudiée durant le travail de Bachelor.
Toutes les difficultés rencontrées durant ce travail sont bénéfiques puisqu'elles ont pu prodiguer à ce projet non seulement d'excellents enseignements, qui seront aussi utilisables dans la vie de tous les jours.  

Nous avons établi que le travail est performant, qu'il fonctionne de façon optimale, mais qu'il est encore difficile d'accès pour un utilisateur final. Une amélioration semblant tout à fait nécessaire serait la conception et l'implémentation d'une interface (+WYSIWYG_a) : l'utilisateur pourrait définir son playbook en connectant des boîtes et des fils, chaque boîte représentant une tâche spécifique (ouvrir un fichier, scraper un document, etc.). De cette façon, l'objectif d'avoir un scraper accessible à tous et à toutes serait encore plus atteint. De plus, en proposant une interface graphique à l'utilisateur (comme une page web), on peut faire abstraction de la complexité de l'infrastructure du point de vue utilisateur.

Dans ce cadre, on quitte un peu le cadre du logiciel de scraping : un logiciel (+WYSIWYG_a) de type "workflow" (c'est-à-dire comme indiqué plus haut, à base de boîtes et de fils connectables) se rapproche plus d'un utilitaire "à tout faire" que d'un logiciel de scraping, puisqu'on peut tout à fait choisir de s'en servir pour autre chose que du téléchargement en masse de documents. Ça n'est toutefois pas un problème à priori et c'est dans cette direction que nous nous dirigerons lors du prochain travail.

\pagebreak