# Annexes {-}

\newappendix{Exemple de fichier playbook}
```yaml
clients: # The default management port for a client is 18965
  - "129.194.187.141"
  - "129.194.187.142"

chapters:
  File Parser:
    file: ./resources/merchandises/EUMerchIDs.txt
    server: yes # Will be run on server
    instructions:
      read: yes
    then:

      Regex Parser:
        input: "!fileParserOutput"
        regex: "[0-9]{4}.[0-9]{4}"
        server: yes # Will not be sent to client
        then: # Sent to client from here only !

          Swiss Impex:
            year: {start: 1989, end: 2020} # 1989 - 2019
            month: {start: 0,   end: 12}
            merchandiseId: "!regexParserOutput"
            then:

              XLSX Parser:
                file: "!swissImpexOutputfileName"
                from: "A6"
                to: "H197"
                instructions:
                  - replace:
                    - "*"
                    - ""
                  - export: csv
                  - cleanup: yes
```

\pagebreak

\newappendix{Fichier fao-geneve.yml}
```yaml
clients: # The default management port for a client is 18965
  - "127.0.0.1"
  - "129.194.187.130" # Comment me for 1M1T

chapters:
  FAO Geneve:
    pages: {start: 0, end: 100} # From 0 to 100 included
```

\pagebreak

\newappendix{Manuel d'installation}
Ce manuel permet l'installation d'Inari sur un poste.

#### Prérequis

Il est nécessaire d'installer une version de Firefox récente (la version 74, par exemple). Il faut installer les paquets suivants :

* Python 3.8
* SSH
* git
* gcc
* default-libmysqlclient-dev 

Il faut un serveur MySQL (au moins en version 5.8) accessible. Un exemple d'installation de MySQL sur un [Ubuntu 18.04 est accessible en cliquant ici](https://www.digitalocean.com/community/tutorials/comment-installer-mysql-sur-ubuntu-18-04-fr).

#### Installation

Pour commencer, il faut installer les dépendances python en allant dans le dossier `projet` et en lancant la commande `python3.8 -m pip install --user -r requirements.txt`.

Une fois que le serveur MySQL est fonctionnel, il faut créer une base de données nommée _bachelor_. Cela fait, il faut créer les tables nécessaires au fonctionnement de ce projet. Cela est faisable soit en se connectant avec un [logiciel de gestion de base de données](https://www.mysql.com/fr/products/workbench/), ou directement depuis la console : `mysql --u<utilisateur mysql> -p <mot de passe MySQL> < resources/my.sql`.

Maintenant que vous avez configuré le serveur MySQL, il faut configurer le serveur et le client pour qu'ils puissent se connecter au serveur MySQL.

Copiez le fichier `example.env` dans `projet` et nommez le `.env`. Editez ce fichier de la façon suivante :

* `DB_HOSTNAME` est le nom d'hôte complet permettant de se connecter à votre base de données;
* `DB_DATABASE` **doit** être réglé sur "bachelor";
* `DB_USERNAME` est le nom d'utilisateur pour se connecter à la base de données;
* `DB_PASSWORD` est le mot de passe de l'utilisateur MySQL pour se connecter à la base de données
* `FILE_LOCKER` est le dossier où les fichiers téléchargés seront stockés. Vous pouvez mettre n'importe quel dossier, du moment que vous pouvez écrire dedans. Il est **indispensable** de mettre un slash final à votre dossier, de la façon suivante : si vous choisissez `/tmp/mondossier`, vous devrez mettre `/tmp/mondossier/`.
* Enfin, `WORKERS_NUMBER` est le nombre de workers que vous souhaitez avoir sur ce client. Ce paramètre n'est pas important si la machine que vous configurez est un serveur. Si c'est un client, cela déterminera le nombre de processus voulu. En règle générale, ce nombre devrait _toujours_ être fixé selon la formule $WORKERS\_NUMBER = Nombre_{Coeurs logiques} - 2$. Cela laisse donc deux coeurs au système. Mettre le nombre de workers au dessus du nombre de coeurs logiques provoquera une diminution drastique des performances.

Laissez les autres paramètres sans les toucher.

Vous avez presque fini l'installation.

#### Démarrage de l'application pour la première fois.

Inari est prêt à être démarré. Depuis le dossier `projet` (travaillez toujours dans/depuis ce dossier), démarrez les commandes suivantes :

* Sur le client, démarrez `python3.8 src/start.py --remote`. `--remote` permet d'accepter des commandes en provenance d'autres ordinateurs. Si la machine accueillant le client est aussi celle pour le serveur, ce paramètre est facultatif. Le client doit être lancé avant le serveur.
* Sur le serveur démarrez `python3.8 src/start.py --remote --server --playbook <votre playbook>`. Des exemples de playbook sont disponibles dans le dossier `resources/playbooks`.
D'autres options sont disponibles pour le serveur. Elles sont documentées en faisant `python3.8 src/start.py --help`.

Une fois le serveur démarré, un lien (+HTTP_a) est généré. Dirigez-vous dessus. Si une interface web apparaît, c'est que tout fonctionne convenablement. Vous pouvez suivre les instructions indiquées par le serveur pour lancer votre premier playbook.

A partir de cet instant, vous pouvez faire fonctionner Inari normalement.

\pagebreak